using System;
using System.Drawing;
using System.Collections;
using System.Collections.Specialized; 
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;

namespace ComboBox
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
    {
        private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            ((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
            this.SuspendLayout();
            // 
            // gridGroupingControl1
            // 
            this.gridGroupingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                        | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
            this.gridGroupingControl1.Location = new System.Drawing.Point(12, 12);
            this.gridGroupingControl1.Name = "gridGroupingControl1";
            this.gridGroupingControl1.Size = new System.Drawing.Size(504, 350);
            this.gridGroupingControl1.TabIndex = 0;
            this.gridGroupingControl1.Text = "gridGroupingControl1";
            this.gridGroupingControl1.VersionInfo = "4.402.0.51";
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(528, 374);
            this.Controls.Add(this.gridGroupingControl1);
            this.Name = "Form1";
            this.Text = "Form1";
            this.Load += new System.EventHandler(this.Form1_Load);
            ((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{

            MyTable a = new MyTable();
            for (int i = 0; i < 10; i++)
            {
                MyRow test = new MyRow(EnumData.Example1);
                a.Add(test);
            }
            gridGroupingControl1.DataSource = a;

            GridEngine engine = gridGroupingControl1.Engine;
            GridTableDescriptor parentTD = (GridTableDescriptor)engine.TableDescriptor;

            gridGroupingControl1.Appearance.AnyCell.ShowButtons = GridShowButtons.ShowCurrentRow;

            gridGroupingControl1.TableModel.CellModels.Add("MyComboBox", new MyComboBoxCellModel(gridGroupingControl1.TableModel));

            GridTableCellStyleInfo valueStyle = parentTD.Columns["Data"].Appearance.AnyRecordFieldCell;
            valueStyle.CellType = "MyComboBox";
            valueStyle.CellValueType = typeof(string);
		}
	}

	public class MyComboBoxCellModel : GridComboBoxCellModel
	{
		public MyComboBoxCellModel(GridModel grid)
			: base(grid)
		{
		 
		}

		public override GridCellRendererBase CreateRenderer(GridControlBase control)
		{
			return new MyComboBoxCellRenderer(control, this);
		}
	}

	public class MyComboBoxCellRenderer : GridComboBoxCellRenderer
	{
        string[] m_Names;
        private Hashtable DisplayCellValue;

		public MyComboBoxCellRenderer(GridControlBase grid, GridCellModelBase cellModel)
			: base(grid, cellModel)
		{
			this.SupportsFocusControl = false;
            DisplayCellValue = new Hashtable();

            m_Names = Enum.GetNames(typeof(EnumData));
            for (int i = 0; i < m_Names.Length; i++)
            {
                m_Names[i] += "Localized";
            }
            this.Grid.DrawCellDisplayText += new GridDrawCellDisplayTextEventHandler(Grid_DrawCellDisplayText);  
		}

        void Grid_DrawCellDisplayText(object sender, GridDrawCellDisplayTextEventArgs e)
        {
            string hashCode = GetHashCode(e.RowIndex,e.ColIndex);
            if( DisplayCellValue.Contains(hashCode))
            {
                Console.WriteLine(DisplayCellValue[hashCode] +"::" + hashCode);  
                e.DisplayText = DisplayCellValue[hashCode].ToString();
            }
        }
        public string GetHashCode(int RowIndex,int ColIndex)
        {
            return "#" + RowIndex + "#-#" + ColIndex + "#";
        }
        protected override void OnInitialize(int rowIndex, int colIndex)
        {
            base.OnInitialize(rowIndex, colIndex);
            string hashCode = GetHashCode(rowIndex,colIndex);
            if (DisplayCellValue.Contains(hashCode))
            {
                ControlValue = DisplayCellValue[hashCode].ToString();
            }
        }
        
        protected override void ListBoxClick(object sender, EventArgs e)
        {
            string hashCode = GetHashCode(CurrentCell.RowIndex, CurrentCell.ColIndex);
            DisplayCellValue[hashCode] = (sender as ListBox).SelectedItem; 
            base.ListBoxClick(sender, e);
        }
	
		protected override void OnShowDropDown()
		{
            ListBoxPart.DataSource = null;
			this.ListBoxPart.Items.Clear();
            this.ListBoxPart.Items.AddRange(m_Names); 
			base.OnShowDropDown ();
		}

		public override bool ProcessMouseWheel(MouseEventArgs e)
		{
			if (this.IsDroppedDown)
			{
				if (e.Delta < 0)
					this.ListBoxPart.TopIndex++;
				else
					this.ListBoxPart.TopIndex--;
				return true;
			}
			return false;
		}
	}

    public class MyTable : BindingList<MyRow>
    {
    }

    public class MyRow
    {
        public MyRow(EnumData data)
        {
            m_Data = Data;
        }

        private EnumData m_Data;

        public EnumData Data
        {
            get { return m_Data; }
            set { m_Data = value; }
        }


    }

    public enum EnumData
    {
        Example1,
        Example2,
        Example3
    }
}
